//+------------------------------------------------------------------+
//|                                       RandomIndicatorSignals.mq4 |
//|                                                     Antonuk Oleg |
//|                                                   banderass@i.ua |
//+------------------------------------------------------------------+
#property copyright "Antonuk Oleg"
#property link      "banderass@i.ua"


#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 15


//#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 RoyalBlue
#property indicator_color2 Crimson
#property indicator_color3 RoyalBlue
#property indicator_color4 Crimson
#property indicator_color5 RoyalBlue
#property indicator_color6 Crimson
#property indicator_color7 RoyalBlue
#property indicator_color8 Crimson
//---- input parameters
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,110);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,110);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(1,0.0);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,110);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexEmptyValue(2,0.0);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,110);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexEmptyValue(3,0.0);
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexArrow(4,110);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexEmptyValue(4,0.0);
   SetIndexStyle(5,DRAW_ARROW);
   SetIndexArrow(5,110);
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexEmptyValue(5,0.0);
   SetIndexStyle(6,DRAW_ARROW);
   SetIndexArrow(6,110);
   SetIndexBuffer(6,ExtMapBuffer7);
   SetIndexEmptyValue(6,0.0);
   SetIndexStyle(7,DRAW_ARROW);
   SetIndexArrow(7,110);
   SetIndexBuffer(7,ExtMapBuffer8);
   SetIndexEmptyValue(7,0.0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+


int start()
{


   int   counted_bars=IndicatorCounted();
         if(counted_bars<0) return(-1);
         if(counted_bars>0) counted_bars--;
            int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   
   for(int i=limit; i>=0; i--)
   { 
      double im4  = iMA(NULL,0, 4,0,MODE_SMA,0,i);
      double im8  = iMA(NULL,0, 8,0,MODE_SMA,0,i);
      double im10 = iMA(NULL,0,10,0,MODE_SMA,0,i);
      double im12 = iMA(NULL,0,12,0,MODE_SMA,0,i);
      double im20 = iMA(NULL,0,20,0,MODE_SMA,0,i); 
      
    
  //-------------------------------------/
      
      if(im4>im12&&(im4<Close[i]&&im8<Close[i]&&im10<Close[i]&&im12<Close[i])){
          ExtMapBuffer7[i]=11;}
      else
          ExtMapBuffer7[i]=0.0;
         

      
      if(im4<im12&&(im4>Close[i]&&im8>Close[i]&&im10>Close[i]&&im12>Close[i])){
          ExtMapBuffer8[i]=11;}
      else
          ExtMapBuffer8[i]=0.0;
   //-------------------------------------/        
               
     double cci=iCCI(NULL,0,20,0,i); 
     double st2=iStochastic(Symbol(),0,12,12,5,MODE_SMA,0,MODE_MAIN,i);    
    
     if(cci >0 && st2>50) {         
         ExtMapBuffer5[i]=8;}
     else
         ExtMapBuffer5[i]=0.0;
         
         
     if(cci <0 && st2<50){         
         ExtMapBuffer6[i]=8;}
     else
         ExtMapBuffer6[i]=0.0;       
  //-------------------------------------/
     if(im8>im20&&(im8<Close[i]&&im10<Close[i]&&im12<Close[i]&&im20<Close[i])){
         ExtMapBuffer1[i]=5;}
     else
         ExtMapBuffer1[i]=0.0;
         

      
     if(im8<im20&&(im8>Close[i]&&im10>Close[i]&&im12>Close[i]&&im20>Close[i])){
         ExtMapBuffer2[i]=5;}
     else
         ExtMapBuffer2[i]=0.0;   
    //-------------------------------------/
         
      double st=iStochastic(Symbol(),0,11,3,3,MODE_SMA,0,MODE_MAIN,i);
      if((st<20||st>80)&&im8>im20&&(im8<Close[i]&&im10<Close[i]&&im12<Close[i]&&im20<Close[i])){
         ExtMapBuffer3[i]=2;}
      else
         ExtMapBuffer3[i]=0.0;
         
         
      
      if((st<20||st>80)&&im8<im20&&(im8>Close[i]&&im10>Close[i]&&im12>Close[i]&&im20>Close[i])){
         ExtMapBuffer4[i]=2;}
      else
         ExtMapBuffer4[i]=0.0;       
         
   }
   
   if (alertsOn)
   {
      if (alertsOnCurrent)
         int whichBar = 0;
      else   whichBar = 1;
      if (ExtMapBuffer1[whichBar]>0 && ExtMapBuffer3[whichBar]>0 && ExtMapBuffer5[whichBar]>0 && ExtMapBuffer7[whichBar]>0) doAlert(" trend changeed to UP");
      if (ExtMapBuffer2[whichBar]>0 && ExtMapBuffer4[whichBar]>0 && ExtMapBuffer6[whichBar]>0 && ExtMapBuffer8[whichBar]>0) doAlert(" trend changeed to DOWN");
   }   
   return(0);
}

//+------------------------------------------------------------------+
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," kybuk ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," kybuk "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

 


